#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>
#include <string.h>

#define NB_CHAR 100

int main(int argc, char **argv)
{
    gid_t gid = -1;
    uid_t uid = -1;
    struct group *group;
    char *ptr;
    char grp[NB_CHAR];
    int i;

    grp[0] = '\0';
    if (argc == 1) {
	fprintf(stderr, "%s: missing operand", argv[0]);
	return EXIT_FAILURE;
    } else if (argc == 2) {
	fprintf(stderr, "%s: missing operand after `%s'",
		argv[0], argv[1]);
	return EXIT_FAILURE;
    } else {
	for (i = 0; argv[1][i] != '\0'; i++)
	    grp[i] = argv[1][i];
	grp[i] = '\0';

	if (grp[0] != '\0') {
	    gid = strtol(grp, &ptr, 10);
	    if (*ptr != '\0') {
		group = getgrnam(grp);
		gid = group->gr_gid;
	    }	    
	}
	for (i = 2; i < argc; i++) {
	    if (chown(argv[i], uid, gid) == -1) {
		perror(argv[0]);
		return EXIT_FAILURE;
	    }
	}
    }
    return EXIT_SUCCESS;
}
