#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

struct e_flags {
    int n;
    int e;
};

int hextoint(unsigned char c)
{
    switch (c) {
    case 'a': case 'A': return 10;
    case 'b': case 'B': return 11;
    case 'c': case 'C': return 12;
    case 'd': case 'D': return 13;
    case 'e': case 'E': return 14;
    case 'f': case 'F': return 15;
    default: return c - '0';
    }
}

void eprint(char *buf)
{
    int i;
    char c, ch;

    for (i = 0; buf[i] != '\0'; i++) {
	c = buf[i];
	if (buf[i] == '\\') {
	    if (buf[++i] != '\0') {
		switch (buf[i]) {
		case 'a': c = '\a'; break;
		case 'b': c = '\b'; break;
		    /*case 'c': c = '\c'; break; */
		case 'f': c = '\f'; break;
		case 'n': c = '\n'; break;
		case 'r': c = '\r'; break;
		case 't': c = '\t'; break;
		case 'v': c = '\v'; break;
		case 'x':
		{
		    ch = buf[++i];
		    if (!isxdigit(ch)) {
			c = ch;
		    } else {
			c = hextoint(ch);
			i++;
			for (; isxdigit(buf[i]); i++)
			    c = c * 16 + hextoint(buf[i]);
			--i;
		    }
		    break;
		}
		case '0':
		    ch = buf[++i];
		    c = ch - '0';
		    if (ch >= '0' && ch <= '8') {
			i++;
			for (; buf[i] >= '0' && buf[i] <= '8'; i++) {
			    c = c * 8 + (buf[i] - '0');
			}
			i--;
		    } else
			c = ch;
		    break;
		case '\\': c = '\\'; break;
		}
	    }
	}
	fputc(c, stdout);
    }
}

int main(int argc, char **argv)
{
    int c, i;
    struct e_flags *flags;

    flags = calloc(sizeof (struct e_flags), 1);
    while ((c = getopt(argc, argv, "neE")) != -1) {
	switch (c) {
	case 'n': flags->n = 1; break;
	case 'E': flags->e = 0; break;
	case 'e': flags->e = 1; break;
	case '?': return 1;
	}
    }
    for (i = optind; i < argc; i++) {
	if (i > optind)
	    printf(" ");
	if (flags->e) {
	    eprint(argv[i]);
	} else
	    printf("%s", argv[i]);
    }
    if (!flags->n)
	printf("\n");
	    
    return 0;
}
