#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

void tr(FILE *fp, int spaces)
{
    char c;
    int i;

    while ((c = fgetc(fp)) != EOF)
	if (c == '\t')
	    for (i = 0; i < spaces; i++)
		printf(" ");
	else
	    fputc(c, stdout);  
}

int expand(const char *filename, int spaces)
{
    FILE *fp;

    if (!strcmp(filename, "-")) {
	tr(stdin, spaces);
    } else {
	if ((fp = fopen(filename, "r")) != NULL) {
	    tr(fp, spaces);
	    fclose(fp);
	} else
	    return 1;
    }
    return 0;
}

int main(int argc, char **argv)
{
    int i, spaces = 8;
    char c;
    char *ptr;

    while ((c = getopt(argc, argv, "t:")) != -1) {
	switch (c) {
	case 't':
	    spaces = strtol(optarg, &ptr, 10);
	    if (*ptr != '\0') {
		fprintf(stderr, "%s: Seems like you're an idiot\n",
			argv[0]);
		return 1;
	    }
	    break;
	case '?':
	    if (optopt == 'm') 
		fprintf(stderr, "%s: Option -%c required an argument\n",
			argv[0], optopt);
	    return 1;
	}
    }
    if (argc == optind)
	expand("-", spaces);
    else
	for (i = optind; i < argc; i++)
	    if (expand(argv[i], spaces)) {
		perror(argv[0]);
		return 1;
	    }
    return 0;
}
