#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>

struct t_opts
{
    int n;
};

static  FILE* open_input(const char* filename)
{
    if (!strcmp(filename, "-"))
	return(stdin);
    else
	return(fopen(filename, "r"));
}

void	fold(FILE* f, int n)
{
    int		c,i = 0;
    if (n == 0)
	n = 80;
    for (;;)
    {
       c = fgetc(f);
       if (c == EOF)
	   break;
       else
       {
	   if (i == n)
	   {
	       printf("\n");
	       i = 0;
	   }
	   printf("%c", c);
	   i++;
       }
    }
}

int     main(int argc,char ** argv)
{
    int c;
    struct t_opts       opts;
    opts.n = 0;
    while ((c = getopt(argc, argv, "n:")) != -1)
	switch (c)
	{
	    case 'n':
		opts.n = atoi(optarg);
		break;
	    case '?':
		return(1);
	    default:
		abort ();
	}
    while (optind < argc)
    {
	if (opts.n == 0)
	    fold(open_input(argv[optind]), 0);
	else
	    fold(open_input(argv[optind]), opts.n);
	optind++;
    }
    return(0);
}
