#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include <grp.h>

void groups(struct passwd *pwd)
{
    int i, ngroups = 0;
    gid_t *groups = NULL;
    struct group *grp;
    
    getgrouplist(pwd->pw_name, pwd->pw_gid, groups, &ngroups);
    groups = calloc(sizeof (gid_t), ngroups);
    getgrouplist(pwd->pw_name, pwd->pw_gid, groups, &ngroups);
    grp = getgrgid(pwd->pw_gid);
    
    for (i = 0; i < ngroups; i++) {
	if (i > 0)
	    printf(" ");
	grp = getgrgid(groups[i]);
	if (grp != NULL)
	    printf("%s", grp->gr_name);
    }
    puts("");
}

int main(int argc, char **argv)
{
    struct passwd *pwd;

    if (argc > 2) {
	fprintf(stderr, "%s: extra operands\n", argv[0]);
	return 1;
    } else if (argc == 2) {
	if ((pwd = getpwnam(argv[1])) == NULL) {
	    fprintf(stderr, "%s: %s: No such user\n", argv[0], argv[1]);
	    return 1;
	}
    } else
	pwd = getpwuid(getuid());

    groups(pwd);

    return 0;
}
