#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#define NB_CHAR 1000
#define MODE 0777

struct mk_flags {
    int p;
    int v;
    int m;
};

int main(int argc, char **argv)
{
    int c, i, j = 0;
    struct mk_flags *flags;
    mode_t mode;
    char *ptr;
    char buf[NB_CHAR], error[NB_CHAR];


    flags = calloc(sizeof (struct mk_flags), 1);
    while ((c = getopt(argc, argv, "pvm:")) != -1) {
	switch (c) {
	case 'p': flags->p = 1; break;
	case 'v': flags->v = 1; break;
	case 'm':
	    flags->m = 1;
	    mode = strtol(optarg, &ptr, 8);
	    if (*ptr != '\0') {
		fprintf(stderr, "%s: invalid mode argument\n", argv[0]);
		return 1;
	    }
	    break;
	case '?': 
	    if (optopt == 'm')
		fprintf(stderr, "%s: option -%c required an argument\n",
			argv[0], optopt);
	    return 1;
	}
    }
    if (argc == optind) {
	fprintf(stderr, "%s: missing operand\n", argv[0]);
	return 1;
    } else {
	for (i = optind; i < argc; i++) {
	    if (flags->p && strchr(argv[i], '/')) {
		buf[j++] = argv[i][0];
		while (argv[i][j] != '\0') {
		    for (; argv[i][j] != '\0' && argv[i][j] != '/'; j++)
			buf[j] = argv[i][j];
		    buf[j] = '\0';
		    if (argv[i][j] == '\0' ||
			(argv[i][j] == '/' && argv[i][j + 1] == '\0'))
			break;
		    if (mkdir(buf, MODE) != -1 && flags->v)
			printf("%s: created directory, `%s'\n",
			       argv[0], buf);
		    if (flags->m) 
			if (chmod(buf, mode) == -1){
				perror(argv[0]);
				return 1;
			}
		    buf[j++] = '/';
		}
	    }
	    if (mkdir(argv[i], MODE) == -1 && !flags->p &&
		errno != EEXIST) {
		sprintf(error, "%s: cannot create directory `%s'",
			argv[0], argv[i]);
		perror(error);
		return 1;
	    }
	    if (flags->m)
		if (chmod(argv[i], mode) == -1) {
		    perror(argv[0]);
		    return 1;
		}
	    if (flags->v && !flags->p &&
		errno != EEXIST)
		printf("%s: created directory, `%s'\n",
		       argv[0], argv[i]);
	}
    }

    return 0;
}
