#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>

struct	t_opts
{
    char	s; /* separate character */
    int		i; /* increment value used */
    int		v; /* startnum */
};

static  FILE* open_input(const char* filename)
{
    if (!strcmp(filename, "-"))
	return(stdin);
    else
	return(fopen(filename, "r"));
}

void	write_line(FILE* f, char s, int v, int i)
{
    int	c, x;
    int	line = v;
    printf("%6d%c", line, s);
    line = line + i;
    for (;;)
    {
	c = fgetc(f);
	if (c == EOF)
	    break;
	else
	{
	    if (c == '\n')
	    {
		x = fgetc(f);
		if (x == EOF)
		    break;
		else
		{
		    printf("\n%6d%c", line, s);
		    line = line + i;
		    fseek(f, -1, SEEK_CUR);
		}
	    }
	    else
		printf("%c", c);
	}
    }
}

int	main(int argc, char ** argv)
{
    int	c;
    struct t_opts	opts;
    opts.i = 1;
    opts.s = '	';
    opts.v = 1;

    while ((c = getopt(argc, argv, "i:s:v:")) != -1)
	switch(c)
	{
	    case 'i':
		opts.i = atoi(optarg);
		break;
	    case 's':
		opts.s = optarg[0];
		break;
	    case 'v':
		opts.v = atoi(optarg);
		break;
	    case '?':
		return(1);
	    default:
		abort();
	}
    while (optind < argc)
    {
	write_line(open_input(argv[optind]), opts.s, opts.v, opts.i);
	optind++;
    }
    return(0);
}
