#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define NB_CHAR 1000

int prmdir(char *s, int vflag, char *progname)
{
    int i;
    char buf[NB_CHAR];
    int init_len;

    strcpy(buf, s);
    init_len = strlen(buf);
    if (buf[init_len - 1] == '/')
	buf[init_len - 1] = '\0';
    for (i = strlen(buf) - 1; i >= 0;) {
	for (; i >= 0 && buf[strlen(buf) - 1] != '/'; i--)
	    buf[i] = '\0';
	if (i <= 0)
	    break;
	buf[strlen(buf) - 1] = '\0';
	if (rmdir(buf) == -1) {
	    perror(buf);
	    return 1;
	}	
	if (vflag)
	    printf("%s: removing directory, `%s'\n", progname, buf);
    }
    return 0;

}

int main(int argc, char **argv)
{
    int opt, i, pflag = 0, vflag = 0;
    
    while ((opt = getopt(argc, argv, "pv")) != EOF)
	switch (opt) {
	case 'p': pflag = 1; break;
	case 'v': vflag = 1; break; 
	case '?': return 1;
	}
    if (optind == argc) {
	fprintf(stderr, "%s: missing operand\n", argv[0]);
	return 1;
    }
    for (i = optind; i < argc; i++) {
	if (rmdir(argv[i]) == -1) {
	    perror(argv[0]);
	    return 1;
	}	
	if (vflag)
	    printf("%s: removing directory, `%s'\n", argv[0], argv[i]);
	if (pflag) 
	    if (prmdir(argv[i], vflag, argv[0]) == 1)
		return 1;
    }
    
    return 0;
}
