#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NB_CHAR 100

int main(int argc, char **argv)
{
    float i, end, start = 1, step = 1;
    char *ptr;
    char s[NB_CHAR];

    if (argc == 1) {
	fprintf(stderr, "%s: missing operand\n", argv[0]);
	return 1;
    } else if (argc > 4) {
	fprintf(stderr, "%s: extra operand\n", argv[0]);
	return 1;
    } else {
	if (argc >= 3) {
	    start = strtof(argv[1], &ptr);
	    if (*ptr != '\0') {
		fprintf(stderr, "%s: invalid floating point argument: %s\n",
			argv[0], argv[1]);
		return 1;
	    }
	}
	else if (argc == 4) {
	    step = strtof(argv[2], &ptr);
	    if (*ptr != '\0') {
		fprintf(stderr, "%s: invalid floating point argument: %s\n",
			argv[0], argv[2]);
		return 1;
	    }
	}
	end = strtof(argv[argc - 1], &ptr);
	if (*ptr != '\0') {
	    fprintf(stderr, "%s: invalid floating point argument: %s\n",
		    argv[0], argv[argc - 1]);
	    return 1;
	}
	
	for (i = start; i <= end; i += step) {
	    if (i == (int)i)
		printf("%.0f\n", i);
	    else {
		sprintf(s, "%.4f", i);
		while (s[strlen(s) - 1] == '0')
		    s[strlen(s) - 1] = '\0';
		printf("%s\n", s);
	    }
	}
    }
    return 0;
}
