#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>

struct t_opts
{
    int	n;
    int c;
    int	r;
};

static	FILE* open_input(const char* filename)
{
    if (!strcmp(filename, "-"))
	return(stdin);
    else
	return(fopen(filename, "r"));
}

/*
** char_tail positionne l'indicateur du fichier f a la fin de celui-ci, puis
** remonte de n caracteres en arriere et les affiche.
*/
void	char_tail(FILE* f, int n, int r)
{
    int	c;
    /* Option R inactive */
    if (r == 1)
    {
	fseek(f, 0, SEEK_END);
	for (;;)
	{
	    fseek(f, -2, SEEK_CUR);
	    c = fgetc(f);
	    if ((c == EOF) || (n == 0))
		break;
	    else
		printf("%c", c);
	    n--;
	}
    }
    /* Option R active */
    else
    {
	fseek(f, -n, SEEK_END);
	for (;;)
	{
	    c = fgetc (f);
	    if ((c == EOF) || (n == 0))
		break;
	    else
		printf("%c", c);
	    n--;
	}
    }
    fclose (f);
}

/*
** lin_tail positionne l'indicateur a la fin du fichier f,remonte de ligne
** et les affiche ensuite.
*/

void	line_tail(FILE* f, int n, int r)
{
    int	c, line = 0, nbr = 0;;
    fseek(f, -1, SEEK_END);
    for (;;)
    {
	fseek(f, -2, SEEK_CUR);
	c = fgetc(f);
	if (r == 1)
	    printf("%c", c);
	if (line == n)
	    break;
	else
	{
	    nbr++;
	    if (c == '\n')
		line++;
	}
    }
    if (r == 0)
    {
	while (nbr != 0)
	{
	    c = fgetc(f);
	    printf("%c", c);
	    nbr--;
	}
    }
}

int	main(int argc,char ** argv)
{
    int c;
    struct t_opts	opts;
    opts.n = 0;
    opts.c = 0;
    opts.r = 0;
    while ((c = getopt(argc, argv, "rn:c:")) != -1)
	switch (c)
	{
	    case 'r':
		opts.r = 1;
		break;
	    case 'n':
		opts.n = atoi(optarg);
		break;
	    case 'c':
		opts.c = atoi(optarg);
		break;
	    case '?':
		return(1);
	    default:
		abort ();
	}
    while (optind < argc)
    {
    if (opts.n != 0)
	line_tail(open_input(argv[optind]), opts.n, opts.r);
    else
	if (opts.c != 0)
	    char_tail(open_input(argv[optind]), opts.c, opts.r);
	else
	    line_tail(open_input(argv[optind]), 2, 0);
    optind++;
    }
    return(0);
}
