#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#define NB_CHAR 1024

void realtee(FILE *fp, int out)
{
    char *buf;
    
    while ((buf = fgets(buf, NB_CHAR, fp)) != NULL) {
	    if (out)
		printf("%s", buf);
	    fprintf(fp, "%s", buf);
    }
}

int tee(const char *filename, int aflag, int out)
{
    FILE *fp;

    if (!strcmp(filename, "-")) {
	realtee(stdin, out);
    } else {
	if (aflag) {
	    if ((fp = fopen(filename, "w")) != NULL) {
		realtee(fp, out);
		fclose(fp);
	    } else
		return 1;
	} else {
	    if ((fp = fopen(filename, "a")) != NULL) {
		realtee(fp, out);
		fclose(fp);
	    } else
		return 1;
	}   
    }
    return 0;
}

int main(int argc, char **argv)
{
    int opt, aflag, i, out = 1;

    while ((opt = getopt(argc, argv, "a")) != -1) {
	switch (opt) {
	case 'a': aflag = 1; break;
	case '?':
	    return 1;
	}
    }
    if (argc == optind)
	tee("-", aflag, out);
    else
	for (i = optind; i < argc; i++) {
	    if (tee(argv[i], aflag, out)) {
		perror("tee");
		return 1;
	    }
	    out = 1;
	}

    return 0;
}
