#include <stdio.h>
#include <sys/utsname.h>
#include <unistd.h>

static int s, n, r, v, m, o;

static void my_puts(const char* s)
{
    fputs(s, stdout);
    fputs(" ", stdout);
}

int main(int argc, char** argv)
{
    int opt;
    struct utsname u;

    if (argc == 1)
        s = 1;

    while ((opt = getopt(argc, argv, "asnrvmo")) != -1)
    {
        switch (opt)
        {
            case 'a': s = n = r = v = m = o = 1; break;
            case 's': s = 1; break;
            case 'n': n = 1; break;
            case 'r': r = 1; break;
            case 'v': v = 1; break;
            case 'm': m = 1; break;
            case 'o': o = 1; break;
        }
    }
    
    uname(&u);

    if (s)
        my_puts(u.sysname);
    if (n)
        my_puts(u.nodename);
    if (r)
        my_puts(u.release);
    if (v)
        my_puts(u.version);
    if (m)
        my_puts(u.machine);
    if (o)
        my_puts("GNU/Linux");

    puts("");

    return 0;
}
