#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#define SPACES 100

void tr(FILE *fp, int spaces)
{
    char c;
    int i;
    char buf[SPACES];
    
    while ((c = fgetc(fp)) != EOF)
	if (c == ' ') {
	    buf[0] = c;
	    for (i = 1; i < spaces && (c = fgetc(fp)) != EOF && c == ' '; i++)
		buf[i] = c;
	    buf[i] = '\0';
	    if (i == spaces)
		fputc('\t', stdout); 
	    else {
		printf("%s", buf);
		if (c != EOF)
		    fputc(c, stdout);
	    }
	} else
	    fputc(c, stdout);  
}

int unexpand(const char *filename, int spaces)
{
    FILE *fp;

    if (!strcmp(filename, "-")) {
	tr(stdin, spaces);
    } else {
	if ((fp = fopen(filename, "r")) != NULL) {
	    tr(fp, spaces);
	    fclose(fp);
	} else
	    return 1;
    }
    return 0;
}

int main(int argc, char **argv)
{
    int i, spaces = 8;
    char c;
    char *ptr;

    while ((c = getopt(argc, argv, "t:")) != -1) {
	switch (c) {
	case 't':
	    spaces = strtol(optarg, &ptr, 10);
	    if (*ptr != '\0') {
		fprintf(stderr, "%s: Seems like you're an idiot\n",
			argv[0]);
		return 1;
	    }
	    break;
	case '?':
	    if (optopt == 'm') 
		fprintf(stderr, "%s: option -%c required an argument\n",
			argv[0], optopt);
	    return 1;
	}
    }
    if (argc == optind)
	unexpand("-", spaces);
    else
	for (i = optind; i < argc; i++)
	    if (unexpand(argv[i], spaces)) {
		perror(argv[0]);
		return 1;
	    }
    return 0;
}
