/*
** uniq.c for Project in /home/mogmi/prog/C/coreutils
**
** Made by mogmi
** Login   <bidon_m@epita.fr>
**
** Started on  Mon 08 Mar 2010 12:44:25 CET mogmi
** Last update Mon 08 Mar 2010 14:45:45 CET mogmi
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>

static	FILE* open_input(const char* filename)
{
    if (!strcmp(filename, "-"))
	return(stdin);
    else
	return(fopen(filename, "r"));
}

int     str_compare(char s1[], char s2[])
{
    int i = 0;
    while ((s1[i] != '\0') && (s2[i] != '\0') && (s1[i] == s2[i]))
	i++;
    return(s1[i] == s2[i]);
}

void	str_print(char *s)
{
    int	i = 0;
    while (s[i] != '\0')
    {
	printf("%c", s[i]);
	i++;
    }
}

void	str_copy(char src[], char dst[])
{
    int	i = 0;
    while (src[i] != '\0')
    {
	dst[i] = src[i];
	i ++;
    }
}

void    uniq(FILE* f)
{
    int		c, i = 0;
    char	tmp[80] = "";
    char	prec[80] = "";
    for (;;)
    {
	c = fgetc(f);
	if (c == EOF)
	    break;
	else
	{
	    if (c == '\n')
	    {
		/*printf("\nTMP = ");
		  str_print(tmp);
		  printf("\n");
		  printf("PREC = ");
		  str_print(prec);
		  printf("\n");*/
		if (str_compare(tmp, prec) == 0)
		{
		    str_print(tmp);
		    printf("\n");
		}
		i = 0;
		str_copy(tmp, prec);
	    }
	    else
	    {
		tmp[i] = c;
		i++;
	    }
	}
    }
}

/* Main */

int     main(int argc,char ** argv)
{
    int c;
    while ((c = getopt(argc, argv, "")) != -1)
	switch (c)
	{
	    case '?':
		return(1);
	    default:
		abort ();
	}
    while (optind < argc)
    {
	uniq(open_input(argv[optind]));
	optind++;
    }
    return(0);
}
